/**
* isMobile
* responsiveMenu
* headerFixed
* themesflatSearch
* blog_slider
* popupGallery
* portfolioLoadMore
* portfolioSingle_Carousel
* blogLoadMore
* testimonialsServices
* goTop
* logo
* onepage_nav
* page404
* retinaLogos
* removePreloader
*/

;(function($) {

    'use strict'

    var isMobile = {
        Android: function() {
            return navigator.userAgent.match(/Android/i);
        },
        BlackBerry: function() {
            return navigator.userAgent.match(/BlackBerry/i);
        },
        iOS: function() {
            return navigator.userAgent.match(/iPhone|iPad|iPod/i);
        },
        Opera: function() {
            return navigator.userAgent.match(/Opera Mini/i);
        },
        Windows: function() {
            return navigator.userAgent.match(/IEMobile/i);
        },
        any: function() {
            return (isMobile.Android() || isMobile.BlackBerry() || isMobile.iOS() || isMobile.Opera() || isMobile.Windows());
        }
    }; 


    var responsiveMenu = function() {
        var menuType = 'desktop';

        $(window).on('load resize', function() {
            var currMenuType = 'desktop';

            if ( matchMedia( 'only screen and (max-width: 991px)' ).matches ) {
                currMenuType = 'mobile';
            }

            if ( currMenuType !== menuType ) {
                menuType = currMenuType;

                if ( currMenuType === 'mobile' ) {
                    var $mobileMenu = $('#mainnav').attr('id', 'mainnav-mobi').hide();
                    var hasChildMenu = $('#mainnav-mobi').find('li:has(ul)');

                    $('#header .nav').after($mobileMenu);
                    hasChildMenu.children('ul').hide();
                    if (hasChildMenu.find(">span").length == 0) {
                        hasChildMenu.children('a').after('<span class="btn-submenu"></span>');
                    }
                    $('.btn-menu').removeClass('active');
                } else {
                    var $desktopMenu = $('#mainnav-mobi').attr('id', 'mainnav').removeAttr('style');
                    $desktopMenu.find('.sub-menu').removeAttr('style');
                    $('#header').find('.nav-wrap').append($desktopMenu);
              
                }
            }
        });

        $('.btn-menu').on('click', function() {  
            var header = $("#header");
            var offset = 0;
            if (typeof(header.data('offset')) != 'undefined') {
                offset = header.data('offset');
            }
        
            var $top = $(window).scrollTop() + header.height() + header.position().top + offset;
            $('#mainnav-mobi').slideToggle(300);
            $(this).toggleClass('active');
        });

        $(document).on('click', '#mainnav-mobi li .btn-submenu', function(e) {
            $(this).toggleClass('active').next('ul').slideToggle(300);
            e.stopImmediatePropagation()
        });
    }  
        
    var headerFixed = function() {
        if ( $('body').hasClass('header_sticky') ) {
            if ( $('body').hasClass('boxed') ) {

            }else{
            var nav = $('header.widget-header');

            if ( nav.size() != 0 ) {
                var header = $('.header.widget-header');           
                var offsetTop = $('.header.widget-header').offset().top;
                var headerHeight = $('.header').height();
                var buffer  = $('<div>', { height: headerHeight }).insertAfter(header);   
                    buffer.hide();                  

                $(window).on('load scroll', function(){
                     if ( $(window).scrollTop() > offsetTop + 120 ) {
                         $('.header').addClass('downscrolled');
                     } else {
                         $('.header').removeClass('header-small downscrolled');
                     }

                     if ( $(window).scrollTop() > 500 ) {
                         $('.header').addClass('header-small upscrolled');
                     } else {
                         $('.header').removeClass('upscrolled');
                     }
                })
            }
            }
        }     
    };

    var headerFixed1 = function() {
        if ($('body').hasClass('admin-bar')) {
            if ( $('body').hasClass('header_sticky') ) {
                if ( $('body').hasClass('boxed') ) {
                
                }else{
                    var nav = $('.header.bg-white');
                        if ( nav.size() !== 0 ) {

                        $(window).on('load', function(){
                        var header = $('.header.bg-white');           
                        var offsetTop = $('.header.bg-white').offset().top-32;
                        var headerHeight = $('.header.bg-white').height();
                        var buffer  = $('<div>', { height: headerHeight }).insertAfter(header);   
                            buffer.hide();                 

                            $(window).on('load scroll', function(){
                                if ( $(window).scrollTop() > offsetTop  ) {
                                    $('.header.bg-white').addClass('fixed-header');
                                    buffer.show();
                                } else {
                                    $('.header.bg-white').removeClass('header-small fixed-header');
                                    buffer.hide();
                                }
                            })
                       
                        }); // headerFixed style1
                    }
                }
            }
        }else{
            if ( $('body').hasClass('header_sticky') ) {
                if ( $('body').hasClass('boxed') ) {
                
                }else{
                    var nav = $('.header.bg-white');
                        if ( nav.size() !== 0 ) {

                        $(window).on('load', function(){
                        var header = $('.header.bg-white');           
                        var offsetTop = $('.header.bg-white').offset().top;
                        var headerHeight = $('.header.bg-white').height();
                        var buffer  = $('<div>', { height: headerHeight }).insertAfter(header);   
                            buffer.hide();                 

                            $(window).on('load scroll', function(){
                                if ( $(window).scrollTop() > offsetTop  ) {
                                    $('.header.bg-white').addClass('fixed-header');
                                    buffer.show();
                                } else {
                                    $('.header.bg-white').removeClass('header-small fixed-header');
                                    buffer.hide();
                                }
                            })
                       
                        }); // headerFixed style1
                    }
                }
            }
        }
    };

    var themesflatSearch = function () {
       $(document).on('click', function(e) {   
            var clickID = e.target.id;   
            if ( ( clickID != 's' ) ) {
                $('.top-search').removeClass('show');   
                $('.show-search').removeClass('active');             
            } 
        });

        $('.show-search').on('click', function(event){
            event.stopPropagation();
        });

        $('.search-form').on('click', function(event){
            event.stopPropagation();
        });        

        $('.show-search').on('click', function (e) {           
            if( !$( this ).hasClass( "active" ) )
                $( this ).addClass( 'active' );
            else
                $( this ).removeClass( 'active' );
             e.preventDefault();

            if( !$('.top-search' ).hasClass( "show" ) )
                $( '.top-search' ).addClass( 'show' );
            else
                $( '.top-search' ).removeClass( 'show' );
        });
    }

    var blog_slider = function() { 
        if ( $().flexslider ) { 
            $('.featured-post.blog-slider').flexslider({
                animation      :  "slide",
                direction      :  "horizontal", // vertical
                pauseOnHover   :  true,
                useCSS         :  false,
                animationLoop  :  false,
                easing         :  "swing",
                animationSpeed :  500,
                slideshowSpeed :  5000,
                controlNav     :  false,
                directionNav   :  true,
                slideshow      :  true,
                prevText       :  '<i class="fa fa-angle-left"></i>',
                nextText       :  '<i class="fa fa-angle-right"></i>',
                smoothHeight   :  true
                }); // flexslider            
        }
    };   

    var popupGallery = function () {        
        if ( $('a').hasClass('popup-gallery') ) {                
             $(".popup-gallery").magnificPopup({
                type: "image",
                tLoading: "Loading image #%curr%...",
                removalDelay: 600,
                mainClass: "my-mfp-slide-bottom",
                gallery: {
                    enabled: true,
                    navigateByImgClick: true,
                    preload: [ 0, 1 ]
                },
                image: {
                    tError: '<a href="%url%">The image #%curr%</a> could not be loaded.'
                }
            });
        }              
    }   

    var portfolioLoadMore = function() {       
        var $container = $('.portfolio-container') 
        var $nav = ".navigation.portfolio.loadmore a";
        $($nav).on('click', function(e) {
            e.preventDefault();  
            $('<span/>', {
                class: 'infscr-loading',
                text: 'Loading...',
            }).appendTo($container);

            $.ajax({
                type: "GET",
                url: $(this).attr('href'),
                dataType: "html",
                success: function( out ) {
                    var result = $(out).find('.item');                        
                    var nextlink = $(out).find($nav).attr('href');
                    result.css({ opacity: 0 });                        
                    $container.append(result).imagesLoaded(function () {
                        result.css({ opacity: 1 });
                        $container.isotope('appended', result);
                    });
                    if ( nextlink != undefined && result != undefined) {
                        $($nav).attr('href', nextlink);
                        $container.find('.infscr-loading').remove();
                    } else {
                        $container.find('.infscr-loading').addClass('no-ajax').text('All posts loaded.').delay(2000).queue(function() {$(this).remove();});
                        $($nav).remove();
                    }
                },
                error: function() {
                   $container.find('.infscr-loading').addClass('no-ajax').text('All posts loaded.').delay(2000).queue(function() {$(this).remove();});
                   $($nav).remove();
               }
           })
        })        
    }

    var portfolioSingle_Carousel = function() {
        $('.themesflat-carousel').each(function() {            
            if ( $().owlCarousel ) {
                $(this).find('.flat-carousel').owlCarousel({
                    loop: true,
                    nav: true,
                    dots: false,                     
                    autoplay: $('.flat-carousel').data('auto'), 
                    margin: 0,                   
                    responsive:{
                        0:{
                            items: 1
                        },
                        320: {
                            items: 1
                        },
                        480:{
                            items: 1
                        },
                        767:{
                            items: 1
                        },
                        991:{
                            items: 1
                        },
                        1200: {
                            items: 1
                        }
                    }
                });
            }
        });
    };

    var blogLoadMore = function() { 
        var $container = $('.post-wrap'),
        $container_faq = $('.themesflat-faq-shortcodes');
        if ( $('body').hasClass('page-template') ) {
            var $container = $('.blog-shortcode');
        }   

        $('.navigation.loadmore a').on('click', function(e) {
            e.preventDefault(); 
            var $item = 'article';
            if ($(this).parents('nav').hasClass("faq")) {
                $container = $container_faq;
                $item = '.item';
            }

            $('<span/>', {
                class: 'infscr-loading',
                text: 'Loading...',
            }).appendTo($container);

            $.ajax({
                type: "GET",
                url: $(this).attr('href'),
                dataType: "html",
                success: function( out ) {
                    var result = $(out).find($item);  
                    var nextlink = $(out).find('.navigation.loadmore a').attr('href');

                    result.css({ opacity: 0 });
                    if ($container.hasClass('masonry')) {
                        $container.append(result).imagesLoaded(function () {
                            result.css({ opacity: 1 });
                            $container.isotope('appended', result);
                        });
                    }
                    else {
                        result.css({ opacity: 1 });
                        $container.append(result);
                    }

                    if ( nextlink != undefined ) {
                        $('.navigation.loadmore a').attr('href', nextlink);
                        $container.find('.infscr-loading').remove();
                    } else {
                        $container.find('.infscr-loading').addClass('no-ajax').text('All posts loaded.').delay(2000).queue(function() {$(this).remove();});
                        $('.navigation.loadmore a').remove();
                    }
                }
            })
        })       
    }  

    var testimonialsServices = function() {
        $('.testimonials-sidebar').each(function() {             
            if ( $().owlCarousel ) {                
                $('.testimonial03').owlCarousel({
                    loop: true,
                    margin: 0,
                    nav: false, 
                    dots: true,                   
                    autoplay: false,                        
                    responsive:{
                        0:{
                            items: 1
                        },                                              
                        480:{
                            items: 1
                        }, 
                        767:{
                            items: 1
                        },
                        991:{
                            items: 1
                        },
                        1200: {
                            items: 1
                        }
                    }
                });
            }
        });
    };  

    var goTop = function() {
        $(window).scroll(function() {
            if ( $(this).scrollTop() > 800 ) {
                $('.go-top').addClass('show');
            } else {
                $('.go-top').removeClass('show');
            }
        }); 

        $('.go-top').on('click', function() {            
            $("html, body").animate({ scrollTop: 0 }, 1000 , 'easeInOutExpo');
            return false;
        });
    };

    var logo = function() {
        // Elements to inject
        var mySVGsToInject = document.querySelectorAll('img.logo_svg');

        // Trigger the injection
        SVGInjector(mySVGsToInject, {
            pngFallback: 'assets/png'
        });
    }

    var onepage_nav = function () {
        $('.onepage .mainnav > ul > li > a').on('click',function() {           
            var anchor = $(this).attr('href').split('#')[1];
            var largeScreen = matchMedia('only screen and (min-width: 992px)').matches;
            var smallScreen = matchMedia('only screen and (max-width: 991px)').matches;
            var headerHeight = 0;
            headerHeight = $('.header').height();
            if ( anchor ) {
                if ( $('#'+anchor).length > 0 ) {
                   if ( $('.upscrolled').length > 0 && largeScreen ) {
                        headerHeight = headerHeight;
                   } else {
                        headerHeight = 0;
                   }

                    if ($('body').hasClass('admin-bar')) {                   
                        var target = $('#'+anchor).offset().top - headerHeight - 112;
                    }else {
                        var target = $('#'+anchor).offset().top - headerHeight - 80;
                    }

                    if (smallScreen) {
                        var target = $('#'+anchor).offset().top - headerHeight;
                    }

                   $('html,body').animate({scrollTop: target}, 1000, 'easeInOutExpo');
                }
            }
            return false;
        })

        $('.onepage .mainnav ul > li > a').on( 'click', function() {
            $( this ).addClass('active').parent().siblings().children().removeClass('active');
            $(this).parents('#mainnav-mobi').hide();            
                        
        });
    } 
    
    // Retina Logos
    var retinaLogos = function() {
        var retina = window.devicePixelRatio > 1 ? true : false;
        var img_retina = $('.logo .site-logo').data('retina');       
        if( retina ) {
            $('#logo').find('img').attr({src:img_retina,width:'99',height:'19'});           
        }
    };   

    var removePreloader = function() { 
        $(window).load(function() { 

            $('.loading-overlay').fadeOut('slow',function () {
                $(this).remove();
            }); 
        }); 
         
    };


// Dom Ready
$(function() {

    if ( matchMedia( 'only screen and (min-width: 991px)' ).matches ) {
        headerFixed();
        headerFixed1();
    }

    responsiveMenu();
    blog_slider();    
    goTop(); 
    logo();      
    blogLoadMore();
    portfolioLoadMore();
    portfolioSingle_Carousel();  
    themesflatSearch();
    testimonialsServices(); 
    retinaLogos();
    popupGallery();
    onepage_nav();   
    removePreloader();

});
})(jQuery);